<?php
/**
 * Date range fields
 *
 * @package Max
 * @since 0.3.19 - Feb 10, 2006
 * @copyright 2006 M3 Media Services
 * @version $Id: DateRangeField.admin.test.php 4300 2006-02-23 16:38:40Z roh@m3.net $
 */

require_once MAX_PATH . '/lib/max/Admin/Reporting/Field.php';
class DateRangeFieldTest extends UnitTestCase
{
    function testDefaultRange()
    {
        $now = new Date('1989-09-01 04:20:42');
        $field = new DateRangeField($now);
        $this->assertTrue($field->isLastMonth());
    }
}

class DateRangeField_LastWeekTest extends UnitTestCase
{
    /* @var DateRangeField */
    var $field;

    function setUp()
    {
        $now = new Date('1989-09-01 04:20:42');
        $this->field = new DateRangeField($now);
        $this->field->useLastWeek();
    }

    function testActualDates()
    {
        $expected_start = new Date('1989-08-20 00:00:00');
        $expected_end = new Date('1989-08-27 00:00:00');

        $actual_start = $this->field->getStartDate();
        $actual_end = $this->field->getEndDate();

        $this->assertTrue($expected_start->equals($actual_start), '"Last week" should start on the Sunday before last. %s');
        $this->assertTrue($expected_end->equals($actual_end), '"Last week" should end on the previous Saturday night (Sunday morning). %s');
    }

    function testIsLastWeek()
    {
        $this->assertTrue($this->field->isLastWeek());
    }

    function testIsLastMonth()
    {
        $this->assertFalse($this->field->isLastMonth(), 'A date range cannot represent both "last month" and "last week" at the same time.');
    }
}
?>
