<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2005 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: Ip.delivery.php 4289 2006-02-23 07:04:28Z scott@m3.net $
*/

/**
 * @package    MaxPlugins
 * @subpackage DeliveryLimitations
 * @author     Chris Nutting <chris@m3.net>
 */

/**
 * Check to see if this impression contains the valid IP Address.
 *
 * @param string $data The IP address limitation
 * @param string $ad The operator (either '==' or '!=')
 * @return boolean Whether this impression's IP address passes this limitation's test.
 */
function MAX_checkClient_Ip($data, $ad)
{
    if ($data == '') {
        return true;
    }
    $host = $GLOBALS['_MAX']['LIMITATION_DATA']['REMOTE_ADDR'];
    if (!strpos($data, '/')) {
        $net = explode('.', $data);
        for ($i=0;$i<sizeof($net);$i++) {
            if ($net[$i] == '*') {
                $net[$i] = 0;
                $mask[$i] = 0;
            } else {
                $mask[$i] = 255;
            }
        }
        $pnet 	= pack('C4', $net[0], $net[1], $net[2], $net[3]);
        $pmask 	= pack('C4', $mask[0], $mask[1], $mask[2], $mask[3]);
    } else {
        list ($net, $mask) = explode('/', $data);
        $net 	= explode('.', $net);
        $pnet 	= pack('C4', $net[0], $net[1], $net[2], $net[3]);
        $mask 	= explode('.', $mask);
        $pmask 	= pack('C4', $mask[0], $mask[1], $mask[2], $mask[3]);
    }
    $host 	= explode('.', $host);
    $phost 	= pack('C4', $host[0], $host[1], $host[2], $host[3]);
    $expression = ($data == "*" || ($phost & $pmask) == $pnet);
    $operator   = $ad == '==';
    return ($expression == $operator);
}

?>
